package sun.awt.windows;

import java.awt.im.InputMethodRequests;
import java.awt.FontMetrics;
import java.awt.TextArea;
import java.awt.Dimension;
import java.awt.peer.TextAreaPeer;

final class WTextAreaPeer extends WTextComponentPeer implements TextAreaPeer
{
    @Override
    public Dimension getMinimumSize() {
        return this.getMinimumSize(10, 60);
    }
    
    @Override
    public void insert(String s, int n) {
        this.replaceRange(s, n, n);
    }
    
    @Override
    public native void replaceRange(String p0, int p1, int p2);
    
    @Override
    public Dimension getPreferredSize(int n, int n2) {
        return this.getMinimumSize(n, n2);
    }
    
    @Override
    public Dimension getMinimumSize(int n, int n2) {
        FontMetrics fontMetrics = this.getFontMetrics(((TextArea)this.target).getFont());
        return new Dimension(fontMetrics.charWidth('0') * n2 + 20, fontMetrics.getHeight() * n + 20);
    }
    
    @Override
    public InputMethodRequests getInputMethodRequests() {
        return null;
    }
    
    WTextAreaPeer(TextArea textArea) {
        super(textArea);
    }
    
    @Override
    native void create(WComponentPeer p0);
}
